
Redmine - Patch #26030

Like issues and news comments, want to specify the display order of the forum's reply.

2017-05-24 11:26 - Minoru Maeda

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Forums Estimated time: 0.00 hour

Target version: Candidate for next major release   

Description

This patch also applies the setting order of comments in "My account" to the forum.

Related issues:

Related to Redmine - Feature #26033: Respect "Objects per page" option when d... Closed

Related to Redmine - Patch #11120: Order replies of messages boards based on ... New

History

#1 - 2017-05-24 16:37 - Go MAEDA

Thank you for posting the patch.

But I think it would be better not to assume that the value of REPLIES_PER_PAGE constant is always 25. The test in your patch may fail if #26033 is

implemented.

#2 - 2017-05-25 08:57 - Minoru Maeda

- File reply_display_order_with_pre_page.patch added

Hello, Go MAEDA. Thank you for your advice.

I improved it in order of reply display considering "per_page".

#3 - 2017-06-22 13:29 - Toshi MARUYAMA

- Related to Feature #26033: Respect "Objects per page" option when displaying forum replies added

#4 - 2017-06-22 13:31 - Toshi MARUYAMA

- Related to Patch #11120: Order replies of messages boards based on user preference added

#5 - 2017-06-29 15:40 - Go MAEDA

- Target version set to 4.1.0

The patch works fine for me. And it also implements #26033.

Setting target version to 3.5.0.

#6 - 2019-06-16 16:44 - Popoki Tom (@cat_in_136)

This patch is great work but sometimes did not work well on my environment.

my environment:

MySQL 5.6.42 (ClearDB)

Ruby 2.5.5p157

Redmine 4.0.3 + reply_display_order_with_pre_page.patch

When showing the topic where

count of the topic children is larger than per_page_option, and

some children has more than one attachment files

In which case, r=xx parameter may not be expanded correctly due to incorrect paging.

On my environment, @replies.pluck(:id) generated an array containing duplicate IDs.

I could not identify the root cause, but I found a line includes(:author, :attachments, {:board => :project}) cause this problem.

Therefore, I corrected this problem as follows to avoid this problem:
--- a/app/controllers/messages_controller.rb

+++ b/app/controllers/messages_controller.rb

@@ -34,7 +34,6 @@ class MessagesController < ApplicationController

     # Find the page of the requested reply

     replies_order = User.current.wants_comments_in_reverse_order? ? 'DESC' : 'ASC'

     @replies = @topic.children.

-      includes(:author, :attachments, {:board => :project}).

       reorder("#{Message.table_name}.created_on #{replies_order}, #{Message.table_name}.id #{replies_order}")

     if params[:r] && page.nil?

@@ -45,6 +44,7 @@ class MessagesController < ApplicationController

     @reply_count = @replies.count

     @reply_pages = Paginator.new @reply_count, per_page_option, page

     @replies = @replies.

+      includes(:author, :attachments, {:board => :project}).

       limit(@reply_pages.per_page).

       offset(@reply_pages.offset).

       to_a

#7 - 2019-09-01 13:05 - Popoki Tom (@cat_in_136)

- File reply_display_order_with_pre_page_2.patch added

I improved Minoru-Maeda-san's patch. My patch includes:

This issue #26030 itself;

display considering "per_page" (#26033);

place "reply" block considering the display order (like #31438);

fix regression that I reported in #26030#note-6;

fix regression where redirection after deleting a message raises an error; and

fix test codes to pass rails test -n /Message.*Test/.

#8 - 2019-09-01 14:03 - Marius BĂLTEANU

Popoki Tom (Popoki Tom (@cat_in_136)) wrote:

I improved Minoru-Maeda-san's patch. My patch includes:

This issue #26030 itself;

display considering "per_page" (#26033);

place "reply" block considering the display order (like #31438);

fix regression that I reported in #26030#note-6;

fix regression where redirection after deleting a message raises an error; and

fix test codes to pass rails test -n /Message.*Test/.

 Thanks for updating the patch. Can you check the content of test/integration/messages_test.rb? It seems the class class MessagesTest is duplicated.

#9 - 2019-09-28 00:33 - Go MAEDA

- Target version changed from 4.1.0 to 4.2.0

#10 - 2019-09-28 14:52 - Popoki Tom (@cat_in_136)

- File reply_display_order_with_pre_page_3.patch added

Opps, Thank you for checking my patch. I've removed the duplicated MessageTest.

#11 - 2020-01-11 03:00 - Popoki Tom (@cat_in_136)

Popoki Tom (Popoki Tom (@cat_in_136)) wrote:

Opps, Thank you for checking my patch. I've removed the duplicated MessageTest.

 My patch has still a some degrade bug where r=xx parameter may not be expanded correctly. This patch should not be merged.

#12 - 2020-07-05 09:48 - Popoki Tom (@cat_in_136)

- File reply_display_order_with_pre_page_4.patch added

4th revision of the patch attached.

I've rewrite MessageController#show to fix degrade bug where `r=xx` parameter may not be expanded correctly.
My internal testing (dogfooding) is on-going on my private redmine instance.

#13 - 2021-03-25 08:31 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#14 - 2022-03-21 21:08 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

Files

reply_order.patch 2.82 KB 2017-05-24 Minoru Maeda

reply_display_order_with_pre_page.patch 3.87 KB 2017-05-25 Minoru Maeda

reply_display_order_with_pre_page_2.patch 8.97 KB 2019-09-01 Popoki Tom (@cat_in_136)

reply_display_order_with_pre_page_3.patch 7.46 KB 2019-09-28 Popoki Tom (@cat_in_136)

reply_display_order_with_pre_page_4.patch 7.55 KB 2020-07-05 Popoki Tom (@cat_in_136)
